searchNodes=[{"ref":"MyXQL.html","title":"MyXQL","type":"module","doc":"MySQL driver for Elixir."},{"ref":"MyXQL.html#child_spec/1","title":"MyXQL.child_spec/1","type":"function","doc":"Returns a supervisor child specification for a DBConnection pool."},{"ref":"MyXQL.html#close/3","title":"MyXQL.close/3","type":"function","doc":"Closes a prepared query. Returns :ok on success, or raises an exception if there was an error. Options Options are passed to DBConnection.close/3, see it&#39;s documentation for all available options."},{"ref":"MyXQL.html#execute/4","title":"MyXQL.execute/4","type":"function","doc":"Executes a prepared query. Options Options are passed to DBConnection.execute/4, see it&#39;s documentation for all available options. Examples iex&gt; {:ok, query} = MyXQL.prepare(conn, &quot;&quot;, &quot;SELECT ? * ?&quot;) iex&gt; {:ok, %MyXQL.Result{rows: [row]}} = MyXQL.execute(conn, query, [2, 3]) iex&gt; row [6]"},{"ref":"MyXQL.html#execute!/4","title":"MyXQL.execute!/4","type":"function","doc":"Executes a prepared query. Returns %MyXQL.Result{} on success, or raises an exception if there was an error. See: execute/4."},{"ref":"MyXQL.html#json_library/0","title":"MyXQL.json_library/0","type":"function","doc":"Returns the configured JSON library. To customize the JSON library, include the following in your config/config.exs: config :myxql, :json_library, SomeJSONModule Defaults to Jason."},{"ref":"MyXQL.html#prepare/4","title":"MyXQL.prepare/4","type":"function","doc":"Prepares a query to be later executed. To execute the query, call execute/4. To close the query, call close/3. Options Options are passed to DBConnection.prepare/4, see it&#39;s documentation for all available options. Examples iex&gt; {:ok, query} = MyXQL.prepare(conn, &quot;&quot;, &quot;SELECT ? * ?&quot;) iex&gt; {:ok, %MyXQL.Result{rows: [row]}} = MyXQL.execute(conn, query, [2, 3]) iex&gt; row [6]"},{"ref":"MyXQL.html#prepare!/4","title":"MyXQL.prepare!/4","type":"function","doc":"Prepares a query. Returns %MyXQL.Query{} on success, or raises an exception if there was an error. See prepare/4."},{"ref":"MyXQL.html#prepare_execute/5","title":"MyXQL.prepare_execute/5","type":"function","doc":"Prepares and executes a query in a single step. Multiple results If a query returns multiple results (e.g. it&#39;s calling a procedure that returns multiple results) an error is raised. If a query may return multiple results it&#39;s recommended to use stream/4 instead. Options Options are passed to DBConnection.prepare_execute/4, see it&#39;s documentation for all available options. Examples iex&gt; {:ok, _query, %MyXQL.Result{rows: [row]}} = MyXQL.prepare_execute(conn, &quot;&quot;, &quot;SELECT ? * ?&quot;, [2, 3]) iex&gt; row [6]"},{"ref":"MyXQL.html#prepare_execute!/5","title":"MyXQL.prepare_execute!/5","type":"function","doc":"Prepares and executes a query in a single step. Returns {%MyXQL.Query{}, %MyXQL.Result{}} on success, or raises an exception if there was an error. See: prepare_execute/5."},{"ref":"MyXQL.html#query/4","title":"MyXQL.query/4","type":"function","doc":"Runs a query. Text queries and prepared statements MyXQL supports MySQL&#39;s two ways of executing queries: text protocol - queries are sent as text binary protocol - used by prepared statements The query statement is still sent as text, however it may contain placeholders for parameter values. Prepared statements have following benefits: better performance: less overhead when parsing the query by the DB engine better performance: binary protocol for encoding parameters and decoding result sets is more efficient protection against SQL injection attacks The drawbacks of prepared statements are: not all statements are preparable requires two roundtrips to the DB server: one for preparing the statement and one for executing it. This can be alleviated by holding on to prepared statement and executing it multiple times. Options :query_type - use :binary for binary protocol (prepared statements), :binary_then_text to attempt executing a binary query and if that fails fallback to executing a text query, and :text for text protocol (default: :binary) :cache_statement - caches the query with the given name Options are passed to DBConnection.execute/4 for text protocol, and DBConnection.prepare_execute/4 for binary protocol. See their documentation for all available options. Examples iex&gt; MyXQL.query(conn, &quot;CREATE TABLE posts (id serial, title text)&quot;) {:ok, %MyXQL.Result{}} iex&gt; MyXQL.query(conn, &quot;INSERT INTO posts (title) VALUES (&#39;title 1&#39;)&quot;) {:ok, %MyXQL.Result{last_insert_id: 1, num_rows: 1}} iex&gt; MyXQL.query(conn, &quot;INSERT INTO posts (title) VALUES (?)&quot;, [&quot;title 2&quot;]) {:ok, %MyXQL.Result{last_insert_id: 2, num_rows: 1}}"},{"ref":"MyXQL.html#query!/4","title":"MyXQL.query!/4","type":"function","doc":"Runs a query. Returns %MyXQL.Result{} on success, or raises an exception if there was an error. See query/4."},{"ref":"MyXQL.html#rollback/2","title":"MyXQL.rollback/2","type":"function","doc":"Rollback a transaction, does not return. Aborts the current transaction. If inside multiple transaction/3 functions, bubbles up to the top level. Example {:error, :oops} = MyXQL.transaction(pid, fn conn -&gt; MyXQL.rollback(conn, :oops) IO.puts &quot;never reaches here!&quot; end)"},{"ref":"MyXQL.html#start_link/1","title":"MyXQL.start_link/1","type":"function","doc":"Starts the connection process and connects to a MySQL server. Options :protocol - Set to :socket for using UNIX domain socket, or :tcp for TCP (default: :socket) Connecting using UNIX domain socket is the preferred method. If :hostname or :port is set, protocol defaults to :tcp unless :socket is set too. :socket - Connect to MySQL via UNIX domain socket in the given path (default: MYSQL_UNIX_PORT env variable, then &quot;/tmp/mysql.sock&quot;) :socket_options - Options to be given to the underlying socket, applies to both TCP and UNIX sockets. See :gen_tcp.connect/3 for more information. (default: []) :hostname - Server hostname (default: MYSQL_HOST env variable, then &quot;localhost&quot;) :port - Server port (default: MYSQL_TCP_PORT env variable, then 3306) :database - Database (default: nil) :username - Username (default: USER env variable) :password - Password (default: MYSQL_PWD env variable, then nil) :charset - A connection charset. On connection handshake, the charset is set to utf8mb4, but if this option is set, an additional SET NAMES &lt;charset&gt; [COLLATE &lt;collation&gt;] query will be executed after establishing the connection. COLLATE will be added if :collation is set. (default: nil) :collation - A connection collation. Must be given with :charset option, and if set it overwrites the default collation for the given charset. (default: nil) :ssl - Set to true if SSL should be used (default: false) :ssl_opts - A list of SSL options, see :ssl.connect/2 (default: []) :connect_timeout - Socket connect timeout in milliseconds (default: 15_000) :handshake_timeout - Connection handshake timeout in milliseconds (default: 15_000) :ping_timeout - Socket receive timeout when idle in milliseconds (default: 15_000). See DBConnection.ping/1 for more information :prepare - How to prepare queries, either :named to use named queries or :unnamed to force unnamed queries (default: :named) See &quot;Named and Unnamed Queries&quot; section of the MyXQL.Query documentation for more information :disconnect_on_error_codes - List of error code atoms that when encountered will disconnect the connection. See &quot;Disconnecting on Errors&quot; section below for more information. The given options are passed down to DBConnection, some of the most commonly used ones are documented below: :after_connect - A function to run after the connection has been established, either a 1-arity fun, a {module, function, args} tuple, or nil (default: nil) :pool - The pool module to use (default: DBConnection.ConnectionPool) :pool_size - The size of the pool See DBConnection.start_link/2 for more information and a full list of available options. Examples Start connection using the default configuration (UNIX domain socket): iex&gt; {:ok, pid} = MyXQL.start_link([]) {:ok, #PID&lt;0.69.0&gt;} Start connection over TCP: iex&gt; {:ok, pid} = MyXQL.start_link(protocol: :tcp) {:ok, #PID&lt;0.69.0&gt;} Run a query after connection has been established: iex&gt; {:ok, pid} = MyXQL.start_link(after_connect: &amp;MyXQL.query!(&amp;1, &quot;SET time_zone = &#39;+00:00&#39;&quot;)) {:ok, #PID&lt;0.69.0&gt;} Disconnecting on Errors Sometimes the connection becomes unusable. For example, some services, such as AWS Aurora, support failover. This means the database you are currently connected to may suddenly become read-only, and an attempt to do any write operation, such as INSERT/UPDATE/DELETE will lead to errors such as: ** (MyXQL.Error) (1792) (ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION) Cannot execute statement in a READ ONLY transaction. Luckily, you can instruct MyXQL to disconnect in such cases by using the following configuration: disconnect_on_error_codes: [:ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION] This cause the connection process to attempt to reconnect according to the backoff configuration. MyXQL automatically disconnects the connection on the following error codes and they don&#39;t have to be configured: ER_MAX_PREPARED_STMT_COUNT_REACHED To convert error code number to error code name you can use perror command-line utility that ships with MySQL client installation, e.g.: bash$ perror 1792 MySQL error code 1792 (ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION): Cannot execute statement in a READ ONLY transaction."},{"ref":"MyXQL.html#stream/4","title":"MyXQL.stream/4","type":"function","doc":"Returns a stream for a query on a connection. Stream consumes memory in chunks of at most max_rows rows (see Options). This is useful for processing large datasets. A stream must be wrapped in a transaction and may be used as an Enumerable. Options :max_rows - Maximum numbers of rows in a result (default: 500) Options are passed to DBConnection.stream/4, see it&#39;s documentation for other available options. Examples {:ok, results} = MyXQL.transaction(pid, fn conn -&gt; stream = MyXQL.stream(conn, &quot;SELECT * FROM integers&quot;, [], max_rows: max_rows) Enum.to_list(stream) end) Suppose the integers table contains rows: 1, 2, 3, 4 and max_rows is set to 2. We&#39;ll get following results: # The first item is result of executing the query and has no rows data Enum.at(results, 0) #=&gt; %MyXQL.Result{num_rows: 0, ...} # The second item is result of fetching rows 1 &amp; 2 Enum.at(results, 1) #=&gt; %MyXQL.Result{num_rows: 2, rows: [[1], [2]]} # The third item is result of fetching rows 3 &amp; 4 Enum.at(results, 2) #=&gt; %MyXQL.Result{num_rows: 2, rows: [[3], [4]]} Because the total number of fetched rows happens to be divisible by our chosen max_rows, there might be more data on the server so another fetch attempt is made. Because in this case there weren&#39;t any more rows, the final result has 0 rows: Enum.at(results, 3) #=&gt; %MyXQL.Result{num_rows: 0} However, if the table contained only 3 rows, the 3rd result would contain: Enum.at(results, 2) #=&gt; %MyXQL.Result{num_rows: 1, rows: [[3]]} And that would be the last result in the stream."},{"ref":"MyXQL.html#transaction/3","title":"MyXQL.transaction/3","type":"function","doc":"Acquire a lock on a connection and run a series of requests inside a transaction. The result of the transaction fun is return inside an :ok tuple: {:ok, result}. To use the locked connection call the request with the connection reference passed as the single argument to the fun. If the connection disconnects all future calls using that connection reference will fail. rollback/2 rolls back the transaction and causes the function to return {:error, reason}. transaction/3 can be nested multiple times if the connection reference is used to start a nested transaction. The top level transaction function is the actual transaction. Options Options are passed to DBConnection.transaction/3, see it&#39;s documentation for all available options. Examples {:ok, result} = MyXQL.transaction(pid, fn conn -&gt; MyXQL.query!(conn, &quot;SELECT title FROM posts&quot;) end)"},{"ref":"MyXQL.html#t:conn/0","title":"MyXQL.conn/0","type":"type","doc":""},{"ref":"MyXQL.html#t:option/0","title":"MyXQL.option/0","type":"type","doc":""},{"ref":"MyXQL.html#t:start_option/0","title":"MyXQL.start_option/0","type":"type","doc":""},{"ref":"MyXQL.Error.html","title":"MyXQL.Error","type":"exception","doc":""},{"ref":"MyXQL.Error.html#t:t/0","title":"MyXQL.Error.t/0","type":"type","doc":""},{"ref":"MyXQL.Query.html","title":"MyXQL.Query","type":"module","doc":"Query struct returned from a successfully prepared query. Its public fields are: :name - The name of the prepared statement; :num_params - The number of parameter placeholders; :statement - The prepared statement Named and Unnamed Queries Named queries are identified by the non-empty value in :name field and are meant to be re-used. Unnamed queries, with :name equal to &quot;&quot;, are automatically closed after being executed."},{"ref":"MyXQL.Query.html#t:t/0","title":"MyXQL.Query.t/0","type":"type","doc":""},{"ref":"MyXQL.Result.html","title":"MyXQL.Result","type":"module","doc":"Result struct returned from any successful query. Its public fields are: :columns - The column names; :connection_id - The connection ID; :last_insert_id - The ID of the last inserted row; :num_rows - The number of fetched or affected rows; :rows - The result set. A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; :num_warnings - The number of warnings Warnings Depending on SQL MODE, a given query may error or just return warnings. If result.num_warnings is non-zero it means there were warnings and they can be retrieved by making another query: MyXQL.query!(conn, &quot;SHOW WARNINGS&quot;)"},{"ref":"MyXQL.Result.html#t:t/0","title":"MyXQL.Result.t/0","type":"type","doc":""},{"ref":"readme.html","title":"MyXQL","type":"extras","doc":"MyXQL MySQL driver for Elixir. Documentation: http://hexdocs.pm/myxql"},{"ref":"readme.html#features","title":"MyXQL - Features","type":"extras","doc":"Automatic decoding and encoding of Elixir values to and from MySQL text and binary protocols Supports transactions, prepared queries, streaming, pooling and more via DBConnection Supports MySQL 5.5+, 8.0, and MariaDB 10.3 Supports mysql_native_password, sha256_password (*), and caching_sha256_password (*) authentication plugins * These authentication methods require either an SSL connection or the server must exchange its public key during handshake."},{"ref":"readme.html#usage","title":"MyXQL - Usage","type":"extras","doc":"Add :myxql to your dependencies: def deps() do [ {:myxql, &quot;~&gt; 0.2.0&quot;} ] end iex&gt; {:ok, pid} = MyXQL.start_link(username: &quot;root&quot;) iex&gt; MyXQL.query!(pid, &quot;CREATE DATABASE IF NOT EXISTS blog&quot;) iex&gt; {:ok, pid} = MyXQL.start_link(username: &quot;root&quot;, database: &quot;blog&quot;) iex&gt; MyXQL.query!(pid, &quot;CREATE TABLE posts IF NOT EXISTS (id serial primary key, title text)&quot;) iex&gt; MyXQL.query!(pid, &quot;INSERT INTO posts (`title`) VALUES (&#39;Post 1&#39;)&quot;) %MyXQL.Result{columns: nil, connection_id: 11204,, last_insert_id: 1, num_rows: 1, num_warnings: 0, rows: nil} iex&gt; MyXQL.query(pid, &quot;INSERT INTO posts (`title`) VALUES (?), (?)&quot;, [&quot;Post 2&quot;, &quot;Post 3&quot;]) %MyXQL.Result{columns: nil, connection_id: 11204, last_insert_id: 2, num_rows: 2, num_warnings: 0, rows: nil} iex&gt; MyXQL.query(pid, &quot;SELECT * FROM posts&quot;) {:ok, %MyXQL.Result{ columns: [&quot;id&quot;, &quot;title&quot;], connection_id: 11204, last_insert_id: nil, num_rows: 3, num_warnings: 0, rows: [[1, &quot;Post 1&quot;], [2, &quot;Post 2&quot;], [3, &quot;Post 3&quot;]] }} It&#39;s recommended to start MyXQL under supervision tree: defmodule MyApp.Application do use Application def start(_type, _args) do children = [ {MyXQL, username: &quot;root&quot;, name: :myxql} ] Supervisor.start_link(children, opts) end end and then we can refer to it by its :name: iex&gt; MyXQL.query!(:myxql, &quot;SELECT NOW()&quot;).rows [[~N[2018-12-28 13:42:31]]]"},{"ref":"readme.html#mariaex-compatibility","title":"MyXQL - Mariaex Compatibility","type":"extras","doc":"See Mariaex Compatibility page for transition between drivers."},{"ref":"readme.html#data-representation","title":"MyXQL - Data representation","type":"extras","doc":"MySQL Elixir ----- ------ NULL nil bool 1 | 0 int 42 float 42.0 decimal #Decimal&lt;42.0&gt; * date ~D[2013-10-12] ** time ~T[00:37:14] datetime ~N[2013-10-12 00:37:14] **, *** timestamp #DateTime&lt;2013-10-12 00:37:14Z&gt; *** json %{&quot;foo&quot; =&gt; &quot;bar&quot;} **** char &quot;é&quot; text &quot;myxql&quot; binary &lt;&lt;1, 2, 3&gt;&gt; bit &lt;&lt;1::size(1), 0::size(1)&gt;&gt; * See Decimal ** When using SQL mode that allows them, MySQL &quot;zero&quot; dates and datetimes are represented as :zero_date and :zero_datetime respectively. *** Datetime fields are represented as NaiveDateTime, however a UTC DateTime can be used for encoding as well **** MySQL added a native JSON type in version 5.7.8, if you&#39;re using earlier versions, remember to use TEXT column for your JSON field."},{"ref":"readme.html#json-support","title":"MyXQL - JSON support","type":"extras","doc":"MyXQL comes with JSON support out of the box via the Jason library. To use it, add :jason to your dependencies: {:jason, &quot;~&gt; 1.0&quot;} You can customize it to use another library via the :json_library configuration: config :myxql, :json_library, SomeJSONModule"},{"ref":"readme.html#contributing","title":"MyXQL - Contributing","type":"extras","doc":"Run tests: git clone git@github.com:elixir-ecto/myxql.git cd myxql mix deps.get mix test See scripts/ci.sh and scripts/test-versions.sh for scripts used to test against different server versions."},{"ref":"readme.html#license","title":"MyXQL - License","type":"extras","doc":"The source code is under Apache License 2.0. Copyright (c) 2018 Plataformatec Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."}]